import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Task1 {
    public static void main(String[] args) throws IOException{
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int n = Integer.parseInt(st.nextToken());
        MyPoint[] points = new MyPoint[n*2];
        for(int i = 0; i < n*2; i++) {
            st = new StringTokenizer(br.readLine());
            points[i] = new MyPoint(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
        }
        if(n == 1) {
            System.out.println(calculateDistance(points[0], points[1]));
            return;
        }
        int county = 0;
        boolean isYZero = true;
        for(int i = 0; i < n*2; i++) {
            if(points[i].y == 1) {
                county++;
                isYZero = false;
            }
        }
        if(isYZero) {
            Arrays.sort(points);
            int max = -1;
            int dist = -1;
            for(int i = 0; i < n*2; i+=2) {
                dist = calculateDistance(points[i], points[i+1]);
                if(dist > max) {
                    max = dist;
                }
            }
            System.out.println(max);
            return;
        }
        if(county > 0) {
            if(county % 2 == 0) {
                System.out.println(0);
            } else {
                System.out.println(1);
            }
        } else {
            System.out.println(0);
        }
    }

    public static int calculateDistance(Point p1, Point p2) {
        return Math.abs(p1.x - p2.x) + Math.abs(p1.y - p2.y);
    }
}

class MyPoint extends Point implements Comparable<MyPoint> {

    public MyPoint(int x, int y) {
        super(x, y);
    }

    @Override
    public int compareTo(MyPoint o) {
        return this.x - o.x;
    }
}
