import java.awt.*;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Task11 {
    public static void main(String[] args) throws IOException{
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int n = Integer.parseInt(st.nextToken());
        MyPoint2[] points = new MyPoint2[n*2];
        for(int i = 0; i < n*2; i++) {
            st = new StringTokenizer(br.readLine());
            points[i] = new MyPoint2(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
        }
        if(n == 1) {
            System.out.println(calculateDistance(points[0], points[1]));
            return;
        }
        Arrays.sort(points);
        int[] distances = new int[n];
        int index = 0;
        for(int i = 0; i < n*2; i++) {
            if(points[i] == null) {
                continue;
            }
            if(i == n*2-2) {
                int n1 = calculateDistance(points[i], points[i+1]);
                distances[index] = n1;
                break;
            }
            int n1 = calculateDistance(points[i], points[i+1]);
            int n2 = calculateDistance(points[i], points[i+2]);
            if(n2 > n1) {
                distances[index++] = n1;
                points[i] = null;
                points[i+1] = null;
            } else {
                distances[index++] = n2;
                points[i] = null;
                points[i+2] = null;
            }
        }
        System.out.println(Arrays.stream(distances).max().getAsInt());
    }

    public static int calculateDistance(Point p1, Point p2) {
        if(p1 == null || p2 == null) {
            return Integer.MAX_VALUE;
        }
        return Math.abs(p1.x - p2.x) + Math.abs(p1.y - p2.y);
    }
}

class MyPoint2 extends Point implements Comparable<MyPoint2> {

    public MyPoint2(int x, int y) {
        super(x, y);
    }

    @Override
    public int compareTo(MyPoint2 o) {
        int n1 = this.x - o.x;
        return n1 == 0 ? this.y - o.y : n1;
    }
}
