#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define el '\n'
#define ff first
#define ss second
#define pb push_back
#define popb pop_back
#define popf pop_front
#define point pair <ll, ll>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const ll N = 1e6 + 10;
const ll inf = 1e18 + 10;

ll suff[N][3], dp[N], cost[N][3], pref[N][3];
string s;

struct CHT {
    struct line {
        ll k, b;
        line(ll k, ll b) : k(k), b(b) {}
    };
    deque <line> f;
    deque <ll> ind;
    deque <ld> dots;

    ld intersection(line a, line b) {
        return (ld)(b.b - a.b) / (ld)(a.k - b.k);
    }
    void add(line cur, ll id) {
        while (!dots.empty() && intersection(f[f.size() - 2], cur) <= dots.back())
            f.popb(), dots.popb(), ind.popb();

        if (!f.empty())
            dots.pb(intersection(f.back(), cur));
        f.pb(cur);
        ind.pb(id);
    }
    ll get(ll x, ll can) {
        if (f.empty() || ind.back() < can)
            return 0;

        ll l = -1, r = dots.size();
        while (l + 1 < r) {
            ll mid = (l + r) >> 1;

            if (x > dots[mid] || ind[mid] < can) l = mid;
            else r = mid;
        }

        return f[r].k * x + f[r].b;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll tests;
    cin >> tests;

    while (tests--) {
        ll n;
        cin >> n;

        cin >> s;
        s = '#' + s;

        for (ll i = 0; i <= n + 1; i++)
            for (ll j = 0; j < 3; j++)
                suff[i][j] = pref[i][j] = cost[i][j] = 0;

        for (ll i = 1; i <= n; i++)
            suff[i][s[i] - 'A']++;
        for (ll i = n; i >= 1; i--)
            for (ll j = 0; j < 3; j++)
                suff[i][j] += suff[i + 1][j];
        for (ll i = 1; i <= n; i++)
            pref[i][s[i] - 'A']++;
        for (ll i = 1; i <= n; i++)
            for (ll j = 0; j < 3; j++)
                pref[i][j] += pref[i - 1][j];

        for (ll i = n; i >= 1; i--)
            cost[i][0] += (s[i] == 'A' ? suff[i][1] : 0) + cost[i + 1][0];
        for (ll i = n; i >= 1; i--)
            cost[i][1] += (s[i] == 'B' ? suff[i][2] : 0) + cost[i + 1][1];
        for (ll i = n; i >= 1; i--)
            cost[i][2] += (s[i] == 'C' ? suff[i][0] : 0) + cost[i + 1][2];

        for (ll i = 1; i <= n; i++)
            dp[i] = 0;

        CHT ans[3];
        for (ll i = 1; i <= n; i++) {
            dp[i] = dp[i - 1];
            ans[s[i] - 'A'].add({pref[i - 1][s[i] - 'A'], cost[i][s[i] - 'A'] + dp[i - 1]}, i);

            ll l = 0, r = i;
            while (l + 1 < r) {
                ll mid = (l + r) >> 1;

                bool ok = 0;
                for (ll j = 0; j < 3; j++)
                    ok |= suff[mid][j] - suff[i + 1][j] == 0;

                if (ok) r = mid;
                else l = mid;
            }

            string cur = "";
            if (suff[r][0] - suff[i + 1][0] != 0)
                cur += 'A';
            if (suff[r][1] - suff[i + 1][1] != 0)
                cur += 'B';
            if (suff[r][2] - suff[i + 1][2] != 0)
                cur += 'C';

            if (cur.size() == 1)
                continue;
            if (cur == "AC")
                swap(cur[0], cur[1]);

            ll id = cur[0] - 'A';

            dp[i] = max(dp[i], ans[id].get(suff[i + 1][(id + 1) % 3], r) - suff[i + 1][(id + 1) % 3] * pref[i][id] - cost[i + 1][id]);
        }

        cout << dp[n] << el;
    }

    return 0;
}
