#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define el '\n'
#define ff first
#define ss second
#define pb push_back
#define popb pop_back
#define popf pop_front
#define point pair <ll, ll>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const ll N = 1e6 + 10;
const ll inf = 1e18 + 10;

ll suff[N][3], dp[N], cost[N][3], pref[N][3];
string s;

struct CHT {
    struct line {
        ll k, b;
        line(ll k, ll b) : k(k), b(b) {}
    };
    deque <line> f;
    deque <ld> dots;

    ld intersection(line a, line b) {
        return (ld)(b.b - a.b) / (ld)(a.k - b.k);
    }
    void add(line cur, ll id) {
        while (!dots.empty() && intersection(f[f.size() - 2], cur) <= dots.back())
            f.popb(), dots.popb();

        if (!f.empty())
            dots.pb(intersection(f.back(), cur));
        f.pb(cur);
    }
    ll get(ll x) {
        if (f.empty())
            return 0;

        ll l = -1, r = dots.size();
        while (l + 1 < r) {
            ll mid = (l + r) >> 1;

            if (x > dots[mid]) l = mid;
            else r = mid;
        }

        return f[r].k * x + f[r].b;
    }
    void clear() {
        f.clear();
        dots.clear();
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll tests;
    cin >> tests;

    while (tests--) {
        ll n;
        cin >> n;

        cin >> s;
        s = '#' + s;

        for (ll i = 0; i <= n + 1; i++)
            for (ll j = 0; j < 3; j++)
                suff[i][j] = pref[i][j] = cost[i][j] = 0;

        for (ll i = 1; i <= n; i++)
            suff[i][s[i] - 'A']++;
        for (ll i = n; i >= 1; i--)
            for (ll j = 0; j < 3; j++)
                suff[i][j] += suff[i + 1][j];
        for (ll i = 1; i <= n; i++)
            pref[i][s[i] - 'A']++;
        for (ll i = 1; i <= n; i++)
            for (ll j = 0; j < 3; j++)
                pref[i][j] += pref[i - 1][j];

        for (ll i = n; i >= 1; i--)
            cost[i][0] += (s[i] == 'A' ? suff[i][1] : 0) + cost[i + 1][0];
        for (ll i = n; i >= 1; i--)
            cost[i][1] += (s[i] == 'B' ? suff[i][2] : 0) + cost[i + 1][1];
        for (ll i = n; i >= 1; i--)
            cost[i][2] += (s[i] == 'C' ? suff[i][0] : 0) + cost[i + 1][2];

        for (ll i = 1; i <= n; i++)
            dp[i] = 0;

        CHT ans[3];
        for (ll i = 1; i <= n; i++) {
            dp[i] = dp[i - 1];

            if (s[i] == 'A')
                ans[1].clear();
            if (s[i] == 'B')
                ans[2].clear();
            if (s[i] == 'C')
                ans[0].clear();

            ans[s[i] - 'A'].add({pref[i - 1][s[i] - 'A'], cost[i][s[i] - 'A'] + dp[i - 1]}, i);

            for (ll j = 0; j < 3; j++)
                dp[i] = max(dp[i], ans[j].get(suff[i + 1][(j + 1) % 3]) - suff[i + 1][(j + 1) % 3] * pref[i][j] - cost[i + 1][j]);
        }

        cout << dp[n] << el;
    }

    return 0;
}
