n, m = map(int, input().split())

cache: dict[tuple, str] = {}

def find_solution(m: int, startswith: str, double: str, single: str):
    key = (m, startswith, double, single)

    if key in cache:
        return cache[key]

    if m == 1:
        return single
    elif m == 2:
        return double + double
    else:
        result = startswith
        prev = result[-1]
        prev_prev = ""

        for i in range(1, m):
            if prev == single:
                result += double
            elif prev == double and prev_prev in single:
                result += double
            elif prev == double and prev_prev == double:
                result += single
            else:
                raise Exception(prev, prev_prev, result)

            prev_prev = prev
            prev = result[-1]

        cache[key] = result

        return result

def find_solution_n1(m):
    result = find_solution(m, "1", "1", "0")

    if result.endswith("01") or result == "1":
        result = find_solution(m, "0", "1", "0")

    return result.replace("1", " 1").replace("0", " 0")

def find_solution_n2(m):
    result = find_solution(m, "2", "2", "1")

    if result.endswith("12") or result == "2":
        result = find_solution(m, "1", "2", "1")

    result = result.replace("1", " 1").replace("2", " 2")

    return result + "\n" + result

def find_solution_n3(m):
    return find_solution_n1(m) + "\n" + find_solution_n2(m)

def find_solution_n30(m):
    return "\n".join([find_solution_n3(m)] * 10)

def find_solution_n31(m):
    return find_solution_n30(m) + "\n" + find_solution_n1(m)

def find_solution_n32(m):
    return find_solution_n2(m) + "\n" + find_solution_n30(m)

def find_solution_any(n, m):
    n2 = find_solution_n2(m)
    n1 = find_solution_n1(m)

    result = ""
    lines_count = 0

    while True:
        result += "\n" + n1
        lines_count += 1

        if n == lines_count:
            return result
        
        result += "\n" + n2
        lines_count += 2

        if n == lines_count:
            return result

        if n < lines_count:
            break

    result = ""
    lines_count = 0

    while True:
        result += "\n" + n2
        lines_count += 2

        if n == lines_count:
            return result
        
        result += "\n" + n1
        lines_count += 1

        if n == lines_count:
            return result

        if n < lines_count:
            return None


if n == 1:
    print(find_solution_n1(m))
elif n == 2:
    print(find_solution_n2(m))
elif n == 3:
    print(find_solution_n3(m))
elif n == 30:
    print(find_solution_n30(m))
elif n == 31:
    print(find_solution_n31(m))
elif n == 32:
    print(find_solution_n32(m))
elif n == m == 4:
    print("0 1 1 0\n1 2 2 1\n1 2 2 1\n0 1 1 0")
else:
    print(find_solution_any(n, m))



# 1
# 1

# 2 2
# 2 2

# 2 2 1
# 2 2 1

# 1 2 2 1 
# 1 2 2 1

# 2 2 1 2 2
# 2 2 1 2 2


# 1 
# 1
# 0

# 2 2
# 2 2
# 1 1

# 2 2 1
# 2 2 1
# 1 1 0