#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>

using namespace std;
using ll = long long;

struct Vec2 {
    int x;
    int y;
};

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<Vec2> points(n * 2);
    map<int, pair<int, int>> points_by_x{};

    for (auto& point : points) {
        cin >> point.x >> point.y;

        if (point.y == 0) {
            points_by_x[point.x].first++;
        } else {
            points_by_x[point.x].second++;
        }
    }

    int res = 0;
    vector<Vec2> leftover{};

    for (auto iter = points_by_x.begin(); iter != points_by_x.end(); iter++) {
        iter->second.first %= 2;
        iter->second.second %= 2;

        if (iter->second.first == 1 && iter->second.second == 1) {
            res = max(res, 1);
            iter->second = { 0, 0 };
        } else if (iter->second.first == 1) {
            leftover.push_back(Vec2 { iter->first, 0 });
        } else if (iter->second.second == 1) {
            leftover.push_back(Vec2 { iter->first, 1 });
        }
    }

    for (int i = 0; i < leftover.size(); i += 2) {
        res = max(res, points[i + 1].x - points[i].x + abs(points[i + 1].y - points[i].y));
    }

    cout << res << "\n";

    return 0;
}
