#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <limits>

using namespace std;
using ll = long long;

const int inf = numeric_limits<int>::max();

struct Vec2 {
    int x;
    int y;
};

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<Vec2> points(n * 2);
    vector<int> indexes{};

    for (int i = 0; i < n * 2; i++) {
        cin >> points[i].x >> points[i].y;
        indexes.push_back(i);
    }

    int res = inf;

    while (next_permutation(indexes.begin(), indexes.end())) {
        bool bad = false;

        for (int i = 0; i < n * 2; i++) {
            if (indexes[indexes[i]] != i || indexes[i] == i) {
                bad = true;
                break;
            }
        }

        if (bad) {
            continue;
        }

        int curr_res = 0;

        for (int i = 0; i < n * 2; i++) {
            const Vec2& a = points[i];
            const Vec2& b = points[indexes[i]];

            curr_res = max(curr_res, abs(a.x - b.x) + abs(a.y - b.y));
        }

        res = min(res, curr_res);
    }

    cout << res << "\n";

    return 0;
}
