#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

struct Vec2 {
    int x;
    int y;
};

int main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    vector<Vec2> points(n * 2);
    map<int, pair<int, int>> points_by_x{};

    for (auto& point : points) {
        cin >> point.x >> point.y;

        if (point.y == 0) {
            points_by_x[point.x].first++;
        } else {
            points_by_x[point.x].second++;
        }
    }

    int res = 0;
    queue<int> leftover0{};
    queue<int> leftover1{};

    for (auto iter = points_by_x.begin(); iter != points_by_x.end(); iter++) {
        while (leftover0.size() > 0 && iter->second.first > 0) {
            iter->second.first--;
            res = max(res, iter->first - leftover0.front());
            leftover0.pop();
        }

        while (leftover1.size() > 0 && iter->second.second > 0) {
            iter->second.second--;
            res = max(res, iter->first - leftover1.front());
            leftover1.pop();
        }

        while (leftover1.size() > 0 && iter->second.first > 0) {
            iter->second.first--;
            res = max(res, iter->first - leftover1.front() + 1);
            leftover1.pop();
        }

        while (leftover0.size() > 0 && iter->second.second > 0) {
            iter->second.second--;
            res = max(res, iter->first - leftover0.front() + 1);
            leftover0.pop();
        }

        iter->second.first %= 2;
        iter->second.second %= 2;

        if (iter->second.first == 1 && iter->second.second == 1) {
            res = max(res, 1);
            iter->second = { 0, 0 };
        } else if (iter->second.first == 1) {
            leftover0.push(iter->first);
        } else if (iter->second.second == 1) {
            leftover1.push(iter->first);
        }
    }

    cout << res << "\n";

    return 0;
}