from itertools import product

def sieve_primes(n):
    sieve = [True] * (n + 1)
    sieve[0] = sieve[1] = False
    
    for i in range(2, n + 1):
        if not sieve[i]:
            continue

        for j in range(i * i, n + 1, i):
            sieve[j] = False

    return sieve

tests = int(input())

for test in range(tests):
    n, k = map(int, input().split(" "))
    arr = list(map(int, input().split(" ")))

    if n > 4:
        print("not implemented")
        continue

    min_strange = -1
    res = None
    sieve = sieve_primes(100000)

    for seq_indexes in product(range(k), repeat=n):
        sequences = [[] for _ in range(k)]

        for el, seq_index in zip(arr, seq_indexes):
            sequences[seq_index].append(el)

        if any(len(seq) == 0 for seq in sequences):
            continue

        strange = sum(1 if sieve[sum(seq)] else 0 for seq in sequences)

        if strange < min_strange or min_strange == -1:
            min_strange = strange
            res = sequences

    print(min_strange)
    print("\n".join(f"{len(seq)} {' '.join(str(el) for el in seq)}" for seq in res))
