#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    n *= 2;

    pair<ll, ll> a[n];

    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    sort(a, a + n);

    map<pair<ll, ll>, queue<int>> ex;
    for (int i = 0; i < n; i++) {
        ex[a[i]].push(i);
    }

    bool taken[n] = {};

    ll ans = 0;
    int i = 0;
    while (i < n) {
        if (taken[i]) {
            i++;
            continue;
        }
        int j = i + 1;
        while (j < n && taken[j]) {
            j++;
        }

        if (a[i].second != a[j].second && a[i].second == 1 && ex.count({a[j].first, 1}) != 0) {
            int ind = ex[{a[j].first, 1}].front();
            ex[{a[j].first, 1}].pop();
            taken[ind] = true;
            ans = max(ans, abs(a[i].first - a[ind].first) + abs(a[i].second - a[ind].second));
            i = j;
        }
        else {
            taken[j] = true;
            ans = max(ans, abs(a[i].first - a[j].first) + abs(a[i].second - a[j].second));
            i = j + 1;
        }
    }

    printf("%lld\n", ans);
}