#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    n *= 2;

    pair<ll, ll> a[n];

    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    sort(a, a + n);

    ll baseans = 0;
    for (int i = 0; i < n; i += 2) {
        baseans = max(baseans, abs(a[i + 1].first - a[i].first) + abs(a[i + 1].second - a[i].second));
    }

    if (baseans < 2) {
        printf("%i\n", baseans);
        return 0;
    }

    vector<ll> b;
    vector<ll> have[2] = {};
    vector<ll> sum;
    b.reserve(n);
    have[0].reserve(n); have[1].reserve(n);
    sum.reserve(n);

    int m = 0;

    for (int i = 0; i < n; i++) {
        b.push_back(a[i].first);
        have[0].push_back(0); have[1].push_back(0);
        sum.push_back(0);
        int j = i;
        while (j < n && a[j].first == a[i].first) {
            have[a[j].second][m]++;
            sum[m]++;
            j++;
        }
        m++;
    }

    bool can = true;

    for (int i = 0; i < m - 1; i++) {
        if (sum[i] % n == 0) {
            continue;
        }
        sum[i + 1]--;
        if (b[i + 1] - b[i] == baseans) {
            can = false;
            break;
        }
        if (b[i + 1] - b[i] == baseans - 1) {
            if (have[1][i] == 0 && have[0][i + 1] == 0) {
                can = false;
                break;
            }
            if (have[1][i] == 0) {
                have[0][i + 1]--;
                continue;
            }
            if (have[0][i] == 0 && have[1][i + 1] == 0 && have[0][i + 1] > 0) {
                can = false;
                break;
            }
            if (have[0][i] == 0) {
                have[1][i + 1]--;
                continue;
            }
        }

    }

    printf("%lld\n", baseans - can);
}