#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    if (n == 1) {
        if (m % 3 == 0) {
            for (int i = 0; i < m; i += 3) {
                printf("110");
            }
            printf("\n");
        }
        else if (m % 3 == 1) {
            for (int i = 0; i < m - 1; i += 3) {
                printf("011");
            }
            printf("0\n");
        }
        else {
            for (int i = 0; i < m - 2; i += 3) {
                printf("110");
            }
            printf("11\n");
        }
    }



}