#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};


void printOne(int m, int cur) {
    while (m) {
        if (cur == 0) {
            printf("0 ");
            cur = 1;
            m--;
        }
        else {
            if (m == 1) {
                printf("1 ");
                m = 0;
            }
            else {
                printf("1 1 ");
                m -= 2;
            }
            cur = 0;
        }
    }
    printf("\n");
}

void printTwo(int mm, int curr) {
    for (int _ = 0; _ < 2; _++) {
        int m = mm, cur = curr;
        while (m) {
            if (cur == 1) {
                printf("1 ");
                cur = 2;
                m--;
            }
            else {
                printf("2 2 ");
                m -= 2;
                cur = 1;
            }
        }
        printf("\n");
    }
    
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    if (n == 1) {
        if (m % 3 == 0 || m % 3 == 2) {
            printOne(m, 1);
        }
        else if (m % 3 == 1) {
            printOne(m, 0);
        }
    }
    else if (n == 2) {
        if (m % 3 == 0 || m % 3 == 2) {
            printTwo(m, 2);
        }
        else {
            printTwo(m, 1);
        }
    }
    else if (n == 3) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < m - (m % 3); j += 3) {
                if (m % 3 == 1) {
                    printf("1 2 2 ");
                }
                else {
                    printf("2 2 1 ");
                }
            }
            if (m % 3 == 1) {
                printf("1");
            }
            else if (m % 3 == 2) {
                printf("2 2");
            }
            printf("\n");
        }
        for (int j = 0; j < m - (m % 3); j += 3) {
            if (m % 3 == 1) {
                printf("0 1 1 ");
            }
            else {
                printf("1 1 0 ");
            }
        }
        if (m % 3 == 2) {
            printf("1 1 ");
        }
        else if (m % 3 == 1) {
            printf("0 ");
        }
        printf("\n");
    }
    else if (n == 4 && m == 4) {
        printf("0 1 1 0\n1 2 2 1\n1 2 2 1\n0 1 1 0\n");
    }
    else {
        while (n) {
            printOne(m, 0);
            printTwo(m, 1);
            n -= 3;
        }
    }



}