#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};

constexpr int N = 6e5;

int dp[13][N] = {};
int p[13] = {};

int compute(int n, int hash) {
    if (dp[n][hash] != -1) {
        return dp[n][hash];
    }
    int a[n];
    int there = hash;
    for (int i = n - 1; i >= 0; i--) {
        if (there >= 2 * p[i]) {
            a[i] = 2;
            there -= 2 * p[i];
        }
        else if (there >= p[i]) {
            a[i] = 1;
            there -= p[i];
        }
        else {
            a[i] = 0;
        }
    }

    int ans = 0;

    for (int i = 0; i < n - 1; i++) {
        if (a[i + 1] == ((a[i] + 1) % 3)) {
            int newhash = hash;

            newhash -= a[i] * p[i];
            newhash += a[i + 1] * p[i];

            newhash -= a[i + 1] * p[i + 1];
            newhash += a[i] * p[i + 1];

            ans = max(ans, compute(n, newhash) + 1);
        }
    }

    return dp[n][hash] = ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    p[0] = 1;
    for (int i = 1; i < 13; i++) {
        p[i] = p[i - 1] * 3;
    }
    for (int j = 0; j < 13; j++) {
        for (int i = 0; i < N; i++) {
            dp[j][i] = -1;
        }
    }

    for (int n = 1; n < 13; n++) {
        for (int hash = 0; hash < p[n]; hash++) {
            compute(n, hash);
        }
    }

    int T;
    cin >> T;

    while (T--) {
        int n;
        string s;
        cin >> n >> s;
        int here = 0;
        int a[n];
        for (int i = 0; i < n; i++) {
            a[i] = s[i] - 'A';
            here += a[i] * p[i];
        }

        printf("%i\n", dp[n][here]);
        
    }



}