#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,lzcnt")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

struct custom_hash {
    int64_t operator()(int64_t x) {
        const int64_t random_number = chrono::steady_clock::now().time_since_epoch().count();
        x = (x ^ random_number);
        return (x ^ (x >> 16));
    }
};

struct DSU {
    int n;
    vector<int> p, h;

    DSU(int m) {
        n = m;
        p.assign(n + 1, -1);
        h.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            p[i] = i;
            h[i] = 1;
        }
    }

    int findParent(int node) {
        if (p[node] == node) {
            return node;
        }
        return p[node] = findParent(p[node]);
    }

    void unionSets(int a, int b) {
        a = findParent(a);
        b = findParent(b);

        if (a == b) return;

        if (h[a] < h[b]) swap(a, b);

        p[b] = a;
        h[a] += h[b];
    }
};


struct Fenwick {
    int n;
    vector<int> a, fen;

    Fenwick(vector<int>& b) {
        n = b.size() - 1;
        a = b;
        fen.assign(n + 1, 0);

        for (int i = 1; i <= n; i++) {
            fen[i] += a[i];

            if (i + (i & (-i)) <= n) {
                fen[i + (i & (-i))] += fen[i];
            }
        }
    }

    int pref(int i) {
        int j = i;
        int ans = 0;

        while (j > 0) {
            ans += fen[j];
            j -= (j & (-j));
        }
        return ans;
    }

    int query(int l, int r) {
        return pref(r) - pref(l - 1);
    }

    void upd(int i, int val) {
        int j = i;

        while (j <= n) {
            fen[j] -= a[i];
            fen[j] += val;

            j += (j & (-j));
        }

        a[i] = val;
    }
};

constexpr int K = 3e5 + 10;

int cnt[K] = {};

struct triple {
    int a, b, c;
};


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int lp[K] = {};
    for (int i = 2; i < K; i++) {
        for (int j = i; j < K; j += i) {
            if (lp[j] == 0) {
                lp[j] = i;
            }
        }
    }


    int T;
    cin >> T;

    while (T--) {
        int n, k;
        cin >> n >> k;

        vector<int> a(n);
        vector<int> b;
        b.reserve(n);
        
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            if (cnt[a[i]] == 0) {
                b.push_back(a[i]);
            }
            cnt[a[i]]++;
        }
        int m = b.size();
        triple good = {-1, -1, -1};

        for (int i = 0; i < m - 2; i++) {
            if (good.a != -1) break;
            if (cnt[b[i]] >= 3 && (lp[b[i] * 3] != b[i] * 3)) {
                good = {b[i], b[i], b[i]};
                break;
            }
            for (int j = i + 1; j < m - 1; j++) {
                if (good.a != -1) break;
                if (cnt[b[i]] >= 2 && (lp[b[i] * 2 + b[j]] != b[i] * 2 + b[j])) {
                    good = {b[i], b[i], b[j]};
                    break;
                }
                if (cnt[b[j]] >= 2 && (lp[b[i] + 2 * b[j]] != b[i] + 2 * b[j])) {
                    good = {b[i], b[j], b[j]};
                    break;
                }
                for (int k = j + 1; k < m; k++) {
                    if (lp[b[i] + b[j] + b[k]] != b[i] + b[j] + b[k]) {
                        good = {b[i], b[j], b[k]};
                        break;
                    }
                }
            }
        }

        if (good.a == -1 || n - k < 3 || k == 1) {
            int ans = 0;
            int nxtk = k, nxtn = n;
            while (nxtk > 1 && (2 * nxtk > nxtn || (nxtn % 2 == 1))) {
                nxtk--;
                nxtn--;
                ans++;
            }
            if (nxtn % 2 == 1) {
                ans++;
            }

            printf("%i\n", ans);
            nxtk = k, nxtn = n;
            int curi = 0;
            while (nxtk > 1 && (2 * nxtk > nxtn || (nxtn % 2 == 1))) {
                nxtk--;
                nxtn--;
                printf("1 %i\n", a[curi]);
                curi++;
            }
            while (nxtk > 1) {
                printf("2 %i %i\n", a[curi], a[curi + 1]);
                curi += 2;
                nxtk--;
            }
            printf("%i ", n - curi);
            while (curi < n) {
                printf("%i ", a[curi]);
                curi++;
            }
            printf("\n");
        }
        else {
            
            vector<int> inds(3);
            int nxt = 0;

            for (int i = 0; i < n; i++) {
                if (nxt == 0 && a[i] == good.a) {
                    inds[0] = i;
                    nxt++;
                }
                else if (nxt == 1 && a[i] == good.b) {
                    inds[1] = i;
                    nxt++;
                }
                else if (nxt == 2 && a[i] == good.c) {
                    inds[2] = i;
                    break;
                }
            }
            k--;
            n -= 3;
            a.erase(a.begin() + inds[2]);
            a.erase(a.begin() + inds[1]);
            a.erase(a.begin() + inds[0]);
            
            int ans = 0;
            int nxtk = k, nxtn = n;
            while (nxtk > 1 && (2 * nxtk > nxtn || (nxtn % 2 == 1))) {
                nxtk--;
                nxtn--;
                ans++;
            }
            if (nxtn % 2 == 1) {
                ans++;
            }

            printf("%i\n", ans);
            nxtk = k, nxtn = n;
            int curi = 0;
            while (nxtk > 1 && (2 * nxtk > nxtn || (nxtn % 2 == 1))) {
                nxtk--;
                nxtn--;
                printf("1 %i\n", a[curi]);
                curi++;
            }
            while (nxtk > 1) {
                printf("2 %i %i\n", a[curi], a[curi + 1]);
                curi += 2;
                nxtk--;
            }
            printf("%i ", n - curi);
            while (curi < n) {
                printf("%i ", a[curi]);
                curi++;
            }
            printf("\n");

            printf("3 %i %i %i\n", good.a, good.b, good.c);
            
            
        }
        for (int val : b) {
            cnt[val] = 0;
        }
    }



}