#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

ll cor(ll n, vector<pair<ll, ll>> a){
    vector<ll> vec;

    for(int i = 0; i < 2 * n; i++)
        vec.push_back(i);

    ll ans = (ll)(1e18);

    do{
        ll res = 0;

        for(int i = 0; i < 2 * n; i += 2){
            auto p1 = a[vec[i]], p2 = a[vec[i + 1]];
            res = max(res, abs(p1.first - p2.first) + abs(p1.second - p2.second));
        }

        ans = min(ans, res);
    } while(next_permutation(vec.begin(), vec.end()));

    return ans;
}

bool check(vector<pair<ll, ll>> a, ll can){
    set<pair<ll, ll>> vec;

    for(auto i: a){
        if(vec.empty()){
            vec.insert(i);
            continue;
        }

        // find best

        pair<ll, ll> best = {(ll)(1e18), -1};
        for(auto j: vec){
            if(abs(j.first - i.first) + abs(j.second - i.second) <= can){
                if(j.first < best.first || (j.first == best.first && j.second == i.second))
                    best = j;
            }
        }

        if(best.second == -1)
            vec.insert(i);
        else{
            vec.erase(vec.find(best));
        }
    }

    return (vec.empty());
}

bool const local = false;

ll get(pair<ll, ll> a, pair<ll, ll> b){
    return abs(a.first - b.first) + abs(a.second - b.second);
}

int main(){
    srand(time(0));

    ll test = (local ? 1000 : 1);

    while(test--){

    ll n;
    if(!local)
        cin >> n;
    else
        n = 1 + rand() % 3;

    vector<pair<ll, ll>> a(2 * n);
    for(auto &i: a){
        if(!local)
            cin >> i.first >> i.second;
        else{
            i.first = rand() % 5;
            i.second = rand() % 2;
        }
    }

    sort(a.begin(), a.end());
    ll cur = 0;

    vector<vector<pair<ll, ll>>> vec(n);
    for(int i = 0; i < 2 * n; i += 2){
        vec[i / 2] = {a[i], a[i + 1]};
    }

    ll step = 1000;
    bool ok = true;
    while(ok && step > 0){
        ok = false;
        step--;

        for(int i = 0; i < n; i++){
            for(int j = 0; j < n; j++){
                if(i == j)
                    continue;

                ll cur = max(get(vec[i][0], vec[i][1]), get(vec[j][0], vec[j][1]));
                ll can = max(get(vec[i][0], vec[j][1]), get(vec[j][0], vec[i][1]));

                if(can < cur){
                    ok = true;

                    swap(vec[i][1], vec[j][1]);
                }
            }
        }
    }

    ll ans = 0;

    for(auto i: vec)
        ans = max(ans, get(i[0], i[1]));

    if(!local)
        cout << ans << endl;

    }

    return 0;
}
