#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5;
int q_pairs, max_dist = 0;

struct Dot{
    int x, y;
    bool used = false;
} dots[DIM * 2];
bool operator==(Dot& A, Dot& B){
    return A.x == B.x && A.y == B.y;
}
bool comp(Dot& A, Dot& B){
    return A.x < B.x || (A.x == B.x && A.y < B.y);
}

void input(){
    cin >> q_pairs;
    for (int i = 0; i < q_pairs*2; ++i)
        cin >> dots[i].x >> dots[i].y;
}

int dist(Dot& A, Dot& B){
    return abs(A.x - B.x) + abs(A.y - B.y);
}

int find_next_not_used(int ind){
    int i = ind+1;
    while (dots[i].used && i < q_pairs * 2)
        ++i;
    return i;
}

void make_pair(int i, int j){
    max_dist = max(max_dist, dist(dots[i], dots[j]));
    dots[i].used = dots[j].used = true;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input();
    sort(dots, dots + q_pairs * 2, comp);

    int i = 0;
    while (i < 2 * q_pairs - 2){
        if (dots[i] == dots[i+1] && dots[i+1] == dots[i+2])
            dots[i+1].used = dots[i+2].used = true;
        ++i;
    }

    int cnt = 0;
    i = 0;
    int j = find_next_not_used(i), k = find_next_not_used(j), l = find_next_not_used(k);
    while (l < 2 * q_pairs){
        if (dots[i] == dots[j]){
            if (dots[i].x != dots[k].x){
                make_pair(i, j);
                i = k; j = l;
            }
            else if (dots[k].y == dots[l].y){
                make_pair(i, j); make_pair(k, l);
                i = find_next_not_used(l); j = find_next_not_used(i);
            }
            else{
                make_pair(i, k); make_pair(j, l);
                i = find_next_not_used(l); j = find_next_not_used(i);
            }
        }
        else{
            if (dots[i].x == dots[j].x || dots[j].x < dots[k].x){
                make_pair(i, j);
                i = k; j = l;
            }
            else if (dots[j].x == dots[k].x){
                if (dots[j].y == dots[k].y){
                    make_pair(i, j); make_pair(k, l);
                    i = find_next_not_used(l); j = find_next_not_used(i);
                }
                else {
                    if (dots[i].y == dots[l].y){
                        if (dots[i].y == dots[j].y){
                            if (dots[j].x - dots[i].x > dots[l].x - dots[k].x){
                                make_pair(i, j); make_pair(k, l);
                                i = find_next_not_used(l); j = find_next_not_used(i);
                            }
                            else{
                                make_pair(i, k); make_pair(j, l);
                                i = find_next_not_used(l); j = find_next_not_used(i);
                            }
                        }
                        else{
                            if (dots[j].x - dots[i].x <= dots[l].x - dots[k].x){
                                make_pair(i, j); make_pair(k, l);
                                i = find_next_not_used(l); j = find_next_not_used(i);
                            }
                            else{
                                make_pair(i, k); make_pair(j, l);
                                i = find_next_not_used(l); j = find_next_not_used(i);
                            }
                        }
                    }
                    else{
                        if (dots[i].y == dots[j].y){
                            make_pair(i, j); make_pair(k, l);
                            i = find_next_not_used(l); j = find_next_not_used(i);
                        }
                        else{
                            make_pair(i, k); make_pair(j, l);
                            i = find_next_not_used(l); j = find_next_not_used(i);
                        }
                    }
                }
            }
            else{
                make_pair(i, j); make_pair(k, l);
                i = find_next_not_used(l); j = find_next_not_used(i);
            }
        }
        k = find_next_not_used(j); l = find_next_not_used(k);
        //cout << i << ' ' << j << ' ' << k << ' ' << l << '\n';
        //++cnt;
    }
    if (i < 2*q_pairs){
        make_pair(i, j);
    }

    cout << max_dist << '\n';

    return 0;
}
