#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e6;

vector<pair<char,int>> sequence;
pair<long long, long long> dinamica_na_subs[DIM];

void convert_to_sequence(string str){
    int last_ind = 0;
    sequence.clear();
    for (int i = 1; i < str.size(); ++i)
        if (str[i-1] != str[i]){
            sequence.push_back({str[i-1], i - last_ind});
            last_ind = i;
        }
    sequence.push_back({str[str.size()-1], str.size() - last_ind});
}

long long solve_subsequence(int ind_start, int ind_finish){
    dinamica_na_subs[ind_start] = {0, 0};
    for(int i = ind_start + 1; i <= ind_finish; ++i)
        dinamica_na_subs[i] = {dinamica_na_subs[i-1].second + sequence[i].second * sequence[i-1].second,
                               max(dinamica_na_subs[i-1].second, dinamica_na_subs[i-1].first)};
    return max(dinamica_na_subs[ind_finish].second, dinamica_na_subs[ind_finish].first);
}

bool can_swap(char c_1, char c_2){
    return ((c_1 == 'A' && c_2 == 'B') || (c_1 == 'B' && c_2 == 'C') || (c_1 == 'C' && c_2 == 'A'));
}

long long solve(string str){
    convert_to_sequence(str);

    long long res = 0;
    int start_ind = 0;
    for (int i = 1; i < sequence.size(); ++i)
        if (!can_swap(sequence[i-1].first, sequence[i].first)){
            res += solve_subsequence(start_ind, i-1);
            start_ind = i;
        }
    res += solve_subsequence(start_ind, sequence.size()-1);

    return res;
}

void output_sequence(){
    for (int i = 0; i < sequence.size(); ++i)
        cout << sequence[i].first << '\t';
    cout << '\n';
    for (int i = 0; i < sequence.size(); ++i)
        cout << sequence[i].second << '\t';
    cout << '\n';    
}
void output_sub_sequences(){
    for (int i = 0; i < sequence.size(); ++i)
        cout << sequence[i].first << '\t';
    cout << '\n';
    for (int i = 0; i < sequence.size(); ++i)
        cout << dinamica_na_subs[i].first << '\t';
    cout << '\n';
    for (int i = 0; i < sequence.size(); ++i)
        cout << dinamica_na_subs[i].second << '\t';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q_test; cin >> q_test;
    string str;
    for (int i = 0, len_i; i < q_test; ++i){
        cin >> len_i >> str;
        cout << solve(str) << '\n';
        //output_sequence();
        //output_sub_sequences();
    }
}
