//in honor of TimDee


#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <random>

using namespace std;

#define int long long

mt19937 rnd(12);

int inf = 1000000000000;


struct pref_sum {
    vector <int> pref;


    void init(vector <int> a) {
        int n = a.size();

        int p = 0;
        pref.resize(n);
        for (int i = 0 ; i < n ; i++) {
            p += a[i];

            pref[i] = p;
        }
    }


    int get(int l , int r) {
        if (l == 0)
            return pref[r];
        else
            return pref[r] - pref[l - 1];
    }
};

pair <int , int> NULL_ = {0 , -inf};

struct mega_cht {
    vector <pair <int , int>> tree;

    int s = 1;
    void init(int n) {
        s = 1;

        while (s*2 < n)
            s *= 2;

        tree.resize(2*s , NULL_);
    }

    void clear(int ind , int l , int r) {
        tree[ind] = {0 , -inf};

        if (r - l == 1)
            return;

        int m = (l + r)/ 2;

        if (tree[ind*2+1] == NULL_)
            clear(ind*2+1 , l , m);
        if (tree[ind*2+2] == NULL_)
            clear(ind*2+2 , m , r);
    }
};

struct CHT {
    vector <pair <int , int>> vp;


    void add(int k , int x) {
        vp.push_back({k , x});
    }

    void clear_() {
        vp.clear();
    }

    int get(int pos) {
        int ans = -inf;

        for (int i = 0 ; i < vp.size();  i++) {
            ans = max(ans , vp[i].first*pos + vp[i].second);
        }

        return ans;
    }
};









signed main() {

    int times;
    cin >> times;

    while (times--) {
        int n;
        cin >> n;

        string s;
        cin >> s;


        vector <int> dp(n+1 , 0);

        vector <CHT> C;

        C.resize(3);

        vector <int> sum_pos(3);
        vector <int> col(3);

        C[0].add(0 , 0);
        C[1].add(0 , 0);
        C[2].add(0 , 0);

        for (int i = 0 ; i < n ; i++)
        {
            if (i > 0)
                dp[i] =max(dp[i] , dp[i - 1]);

            int x = s[i] - 'A';

            col[x]++;
            sum_pos[x] += i;

            int y_ = (x+ 2) % 3;

            C[y_].clear_();

            for (int j = 0 ; j < 3 ; j++) {
                int x = C[j].get(col[j]);

                x += 2*sum_pos[j];

                x -= col[j]* col[j];
                x += col[j];

                dp[i] = max(dp[i] , x/2);
            }

            for (int j = 0 ; j < 3 ; j++) {
                int k , x;
                k = 2*(-(i+1)+col[j]);

                x = 2*dp[i];
                x -= 2*sum_pos[j];
                x += 2*col[j]*(i+1);
                x -= col[j]*col[j];
                x -= col[j];

                C[j].add(k , x);
            }
        }

        cout << dp[n - 1] << "\n";
    }
}
