import sys

sys.setrecursionlimit(10000)
memo = {}
def find_longest_operation_chain(s):
    global memo
    if s in memo:
        return memo[s]
    max_operations = 0
    branches = []
    for i in range(len(s)-1):
        sub = s[i:i+2]
        if sub in ['AB', 'BC', 'CA']:
            branch = s[:i] + sub[::-1] + s[i+2:]
            branches.append(branch)
    
    if len(branches) == 0:
        memo |= {s: 0}
        return 0
    for branch in branches:
        max_operations = max(max_operations, 1 + find_longest_operation_chain(branch))
    memo |= {s: max_operations}
    return max_operations

def solutionT3(s):
    n_As = 0
    n_operations = 0
    for c in s:
        if c == 'A':
            n_As += 1
            continue
        n_operations += n_As
    return n_operations

def solutionT4(s):
    n_As = 0
    n_Bs = 0
    n_Cs = 0
    for c in s:
        match c:
            case 'A':
                n_As += 1
            case 'B':
                n_Bs += 1
            case 'C':
                n_Cs += 1
    return max(n_As, n_Cs) * n_Bs

T = int(sys.stdin.readline())
for _ in range(T):
    sys.stdin.readline()
    s = sys.stdin.readline().strip()

    if 'C' not in s:
        print(solutionT3)
        continue
    
    current_character = 'A'
    useT4 = True
    for c in s:
        if c == current_character:
            continue
        elif c == (next_c := chr(ord(current_character)+1)):
            current_character = next_c
        else:
            useT4 = False
            break
    if useT4:
        print(solutionT4(s))
        continue
    
    print(find_longest_operation_chain(s))
    