import sys

sys.setrecursionlimit(10000)
memo = {}
def general_solution(s):
    global memo
    if s in memo:
        return memo[s]
    max_operations = 0
    branches = []
    for i in range(len(s)-1):
        sub = s[i:i+2]
        if sub in ['AB', 'BC', 'CA']:
            branch = s[:i] + sub[::-1] + s[i+2:]
            branches.append(branch)
    
    if len(branches) == 0:
        memo |= {s: 0}
        return 0
    for branch in branches:
        max_operations = max(max_operations, 1 + general_solution(branch))
    memo |= {s: max_operations}
    return max_operations

def solutionT3(s):
    n_As = 0
    n_operations = 0
    for c in s:
        if c == 'A':
            n_As += 1
            continue
        n_operations += n_As
    return n_operations

def solutionT4(s):
    n_As = 0
    n_Bs = 0
    n_Cs = 0
    for c in s:
        match c:
            case 'A':
                n_As += 1
            case 'B':
                n_Bs += 1
            case 'C':
                n_Cs += 1
    return max(n_As, n_Cs) * n_Bs

def solutionT5(s):
    n_As = 0
    n_Bs = 0
    n_Cs = 0
    prev_character = None
    n_operations = 0
    for c in s:
        if prev_character and (prev_character + c == 'CB'):
            n_operations += max(n_As, n_Cs) * n_Bs
            n_As = n_Bs = n_Cs = 0
        match c:
            case 'A':
                n_As += 1
            case 'B':
                n_Bs += 1
            case 'C':
                n_Cs += 1
        prev_character = c
    n_operations += max(n_As, n_Cs) * n_Bs
    return n_operations

T = int(sys.stdin.readline())
for _ in range(T):
    sys.stdin.readline()
    s = sys.stdin.readline().strip()

    if 'C' not in s:
        print(solutionT3(s))
        continue
    
    current_character = 'A'

    useT4 = True
    useT5 = True
    prev_character = None
    for c in s:
        if c == (next_c := chr(ord(current_character)+1)):
            current_character = next_c
        elif c != current_character:
            useT4 = False
        if prev_character is not None and prev_character + c == 'CA':
            useT5 = False
        if not (useT4 or useT5):
            break
        prev_character = c
    if useT4:
        print(solutionT4(s))
        continue
    if useT5:
        print(solutionT5(s))
        continue
    
    print(general_solution(s))
    