#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <numeric>
#include <climits>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cstdint>
using namespace std;

struct Point
{
    int x, y;

    friend bool operator<(const Point& p1, const Point& p2)
    {
        if (p1.x < p2.x)
        {
            return 1;
        }
        if (p1.x > p2.x) return 0;
        return p1.y < p2.y;
    }
};

int Dist(Point& p1, Point& p2)
{
    return abs(p1.x - p2.x) + abs(p1.y - p2.y);
}

bool check(vector<Point>& P, int mx)
{
    int j = 1;
    int i = 0;

    int res = 0;
    while (i+1 < P.size())
    {
        while (j+1 < P.size() && Dist(P[j], P[i]) < mx)
        {
            j++;
        }
        while (j-1 > i && Dist(P[j], P[i]) > mx)
        {
            j--;
        }

        res = max(res, Dist(P[j], P[i]));
        i+=2;
        j+=2;
    }

    return res <= mx;
}

void solve()
{
    int n;
    cin >> n;
    vector<Point> P(2*n);

    int count1 = 0;
    int count0 = 0;
    for (int i=0; i<P.size(); i++)
    {
        cin >> P[i].x >> P[i].y;
        if (P[i].y == 0) count0++;
        else if (P[i].y == 1) count1++;
    }

    sort(P.begin(), P.end());

    if (n == 1)
    {
        cout << abs(P[0].x-P[1].x) + abs(P[0].y-P[1].y);
        return;
    }

    if (P[0].x == P[2*n-1].x)
    {
        if (count1%2 == 0 && count0%2 == 0)
        {
            cout << 0 << endl;
        }
        else cout << 1 << endl;
        return;
    }

    // G5 & G6
    // int mx = 0;
    // for (int i=0; i<2*n-1; i+=2)
    // {
    //     mx = max(mx, abs(P[i].x-P[i+1].x) + abs(P[i].y-P[i+1].y));
    // }

    // cout << mx << endl;

    int l = 0;
    int r = 1e9+1;

    int res = 0;
    while (l < r)
    {
        int mid = (l+r)/2;

        bool ch = check(P, mid);
        if (ch)
        {
            r = mid-1;
            res = mid;
        }
        else
        {
            l = mid+1;
        }
    }

    cout << res << endl;

}

int main()
{
    solve();
}